/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * File Name          : freertos.c
  * Description        : Code for freertos applications
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2020 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under Ultimate Liberty license
  * SLA0044, the "License"; You may not use this file except in compliance with
  * the License. You may obtain a copy of the License at:
  *                             www.st.com/SLA0044
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "FreeRTOS.h"
#include "task.h"
#include "main.h"
#include "cmsis_os.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "timers.h"
#include "iwdg.h"
#include "gpio.h"
#include "usart.h"
#include "navikit.h"
#include "coulomb.h"
#include "stdbool.h"
#include "adc.h"
#include "i2c.h"
#include "log.h"
#include "usbd_cdc_if.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN Variables */
extern uint8_t port_restart;
extern bool flag_restart;
//Timer
osTimerId_t PwrBtnLongPressTimerHandle;
const osTimerAttr_t PwrBtnLongPressTimer_attributes = {
  .name = "PwrBtnLongPressTimer"
};
osTimerId_t CustBtnLongPressTimerHandle;
const osTimerAttr_t CustBtnLongPressTimer_attributes = {
  .name = "CustBtnLongPressTimer"
};
osTimerId_t PwrBtnShortPressTimerHandle;
const osTimerAttr_t PwrBtnShortPressTimer_attributes = {
  .name = "PwrBtnShortPressTimer"
};
osTimerId_t CustBtnShortPressTimerHandle;
const osTimerAttr_t CustBtnShortPressTimer_attributes = {
  .name = "CustBtnShortPressTimer"
};
osTimerId_t IdleStateHoldTimerHandle;
const osTimerAttr_t IdleStateHoldTimer_attributes = {
  .name = "IdleStateHoldTimer"
};

//Thread

osThreadId_t cdcMonitorTaskHandle;
const osThreadAttr_t cdcMonitorTask_attributes = {
  .name = "cdcMonitorTask",
  .priority = (osPriority_t) osPriorityNormal,
  .stack_size = 128 * 4
};

osThreadId_t LogtoUartTaskHandle;
const osThreadAttr_t LogtoUartTask_attributes = {
  .name = "LogtoUartTask",
  .priority = (osPriority_t) osPriorityBelowNormal,
  .stack_size = 128 * 4
};

osThreadId_t TestTask1Handle;
const osThreadAttr_t TestTask1_attributes = {
  .name = "TestTask1",
  .priority = (osPriority_t) osPriorityNormal,
  .stack_size = 128 * 4
};
osThreadId_t TestTask2Handle;
const osThreadAttr_t TestTask2_attributes = {
  .name = "TestTask2",
  .priority = (osPriority_t) osPriorityBelowNormal,
  .stack_size = 128 * 4
};

//Queue
//osMessageQueueId_t LogMessageQueueHandle;
//const osMessageQueueAttr_t LogMessageQueue_attributes = {
//  .name = "LogMessageQueue"
//};

/* USER CODE END Variables */
/* Definitions for defaultTask */
osThreadId_t defaultTaskHandle;
const osThreadAttr_t defaultTask_attributes = {
  .name = "defaultTask",
  .priority = (osPriority_t) osPriorityNormal,
  .stack_size = 128 * 4
};
/* Definitions for LedBlinkTask */
osThreadId_t LedBlinkTaskHandle;
const osThreadAttr_t LedBlinkTask_attributes = {
  .name = "LedBlinkTask",
  .priority = (osPriority_t) osPriorityLow,
  .stack_size = 128 * 4
};
/* Definitions for CoulombRead */
osThreadId_t CoulombReadHandle;
const osThreadAttr_t CoulombRead_attributes = {
  .name = "CoulombRead",
  .priority = (osPriority_t) osPriorityLow,
  .stack_size = 128 * 4
};
/* Definitions for PowerMonitTask */
osThreadId_t PowerMonitTaskHandle;
const osThreadAttr_t PowerMonitTask_attributes = {
  .name = "PowerMonitTask",
  .priority = (osPriority_t) osPriorityLow,
  .stack_size = 128 * 4
};
/* Definitions for EventDetect */
osThreadId_t EventDetectHandle;
const osThreadAttr_t EventDetect_attributes = {
  .name = "EventDetect",
  .priority = (osPriority_t) osPriorityLow,
  .stack_size = 128 * 4
};

/* Private function prototypes -----------------------------------------------*/
/* USER CODE BEGIN FunctionPrototypes */

bool isWakeUpReset() {	return  __HAL_PWR_GET_FLAG(PWR_FLAG_WU);}
//callback
void PwrBtnLongPressTimerCallback(void *argument);
void CustBtnLongPressTimerCallback(void *argument);
void PwrBtnShortPressTimerCallback(void *argument);
void CustBtnShortPressTimerCallback(void *argument);

void IdleStateHoldTimerCallback(void *argument);

//task
void StartLogtoUartTask(void *argument);
void StartCdcMonitorTask(void *argument);

void StartTestTask1(void *argument);
void StartTestTask2(void *argument);

/* USER CODE END FunctionPrototypes */

void StartDefaultTask(void *argument);
void StartLedBlinkTask(void *argument);
void StartCoulombRead(void *argument);
void StartPowerMonitTask(void *argument);
void StartEventDetect(void *argument);

extern void MX_USB_DEVICE_Init(void);
void MX_FREERTOS_Init(void); /* (MISRA C 2004 rule 8.1) */

/* Hook prototypes */
void configureTimerForRunTimeStats(void);
unsigned long getRunTimeCounterValue(void);
void vApplicationIdleHook(void);
void vApplicationTickHook(void);
void vApplicationStackOverflowHook(xTaskHandle xTask, signed char *pcTaskName);

/* USER CODE BEGIN 1 */
/* Functions needed when configGENERATE_RUN_TIME_STATS is on */
__weak void configureTimerForRunTimeStats(void)
{

}

__weak unsigned long getRunTimeCounterValue(void)
{
//	return osKernelGetTickCount();
}
/* USER CODE END 1 */

/* USER CODE BEGIN 2 */
void vApplicationIdleHook( void )
{
   /* vApplicationIdleHook() will only be called if configUSE_IDLE_HOOK is set
   to 1 in FreeRTOSConfig.h. It will be called on each iteration of the idle
   task. It is essential that code added to this hook function never attempts
   to block in any way (for example, call xQueueReceive() with a block time
   specified, or call vTaskDelay()). If the application makes use of the
   vTaskDelete() API function (as this demo application does) then it is also
   important that vApplicationIdleHook() is permitted to return to its calling
   function, because it is the responsibility of the idle task to clean up
   memory allocated by the kernel to any task that has since been deleted. */
}
/* USER CODE END 2 */

/* USER CODE BEGIN 3 */
void vApplicationTickHook( void )
{
   /* This function will be called by each tick interrupt if
   configUSE_TICK_HOOK is set to 1 in FreeRTOSConfig.h. User code can be
   added here, but the tick hook is called from an interrupt context, so
   code must not attempt to block, and only the interrupt safe FreeRTOS API
   functions can be used (those that end in FromISR()). */
}
/* USER CODE END 3 */

/* USER CODE BEGIN 4 */
void vApplicationStackOverflowHook(xTaskHandle xTask, signed char *pcTaskName)
{
   /* Run time stack overflow checking is performed if
   configCHECK_FOR_STACK_OVERFLOW is defined to 1 or 2. This hook function is
   called if a stack overflow is detected. */
}
/* USER CODE END 4 */

/* USER CODE BEGIN PREPOSTSLEEP */
__weak void PreSleepProcessing(uint32_t *ulExpectedIdleTime)
{
/* place for user code */

}

__weak void PostSleepProcessing(uint32_t *ulExpectedIdleTime)
{
/* place for user code */

}
/* USER CODE END PREPOSTSLEEP */

/**
  * @brief  FreeRTOS initialization
  * @param  None
  * @retval None
  */
void MX_FREERTOS_Init(void) {
  /* USER CODE BEGIN Init */
       
  /* USER CODE END Init */

  /* USER CODE BEGIN RTOS_MUTEX */
  /* add mutexes, ... */
  /* USER CODE END RTOS_MUTEX */

  /* USER CODE BEGIN RTOS_SEMAPHORES */
  /* add semaphores, ... */
  /* USER CODE END RTOS_SEMAPHORES */

  /* USER CODE BEGIN RTOS_TIMERS */
  /* start timers, add new ones, ... */
  PwrBtnLongPressTimerHandle = osTimerNew(PwrBtnLongPressTimerCallback, osTimerOnce, NULL, &PwrBtnLongPressTimer_attributes);
  CustBtnLongPressTimerHandle = osTimerNew(CustBtnLongPressTimerCallback, osTimerOnce, NULL, &CustBtnLongPressTimer_attributes);
  PwrBtnShortPressTimerHandle = osTimerNew(PwrBtnShortPressTimerCallback, osTimerOnce, NULL, &PwrBtnShortPressTimer_attributes);
  CustBtnShortPressTimerHandle = osTimerNew(CustBtnShortPressTimerCallback, osTimerOnce, NULL, &CustBtnShortPressTimer_attributes);
  IdleStateHoldTimerHandle = osTimerNew(IdleStateHoldTimerCallback, osTimerOnce, NULL, &IdleStateHoldTimer_attributes);

  /* USER CODE END RTOS_TIMERS */

  /* USER CODE BEGIN RTOS_QUEUES */
  /* add queues, ... */
//  LogMessageQueueHandle = osMessageQueueNew (1024, sizeof(uint8_t), &LogMessageQueue_attributes);

  /* USER CODE END RTOS_QUEUES */

  /* Create the thread(s) */
  /* creation of defaultTask */
  defaultTaskHandle = osThreadNew(StartDefaultTask, NULL, &defaultTask_attributes);

  /* creation of LedBlinkTask */
  LedBlinkTaskHandle = osThreadNew(StartLedBlinkTask, NULL, &LedBlinkTask_attributes);

  /* creation of CoulombRead */
//  CoulombReadHandle = osThreadNew(StartCoulombRead, NULL, &CoulombRead_attributes);

  /* creation of PowerMonitTask */
//  PowerMonitTaskHandle = osThreadNew(StartPowerMonitTask, NULL, &PowerMonitTask_attributes);

  /* creation of EventDetect */
  EventDetectHandle = osThreadNew(StartEventDetect, NULL, &EventDetect_attributes);

  /* USER CODE BEGIN RTOS_THREADS */
  /* add threads, ... */
//   LogtoUartTaskHandle = osThreadNew(StartLogtoUartTask, NULL, &LogtoUartTask_attributes);
//  TestTask1Handle = osThreadNew(StartTestTask1, NULL, &TestTask1_attributes);
//  TestTask2Handle = osThreadNew(StartTestTask2, NULL, &TestTask2_attributes);

  cdcMonitorTaskHandle = osThreadNew(StartCdcMonitorTask, NULL, &cdcMonitorTask_attributes);

  /* USER CODE END RTOS_THREADS */

  /* USER CODE BEGIN RTOS_EVENTS */
  /* add events, ... */
  /* USER CODE END RTOS_EVENTS */

}

/* USER CODE BEGIN Header_StartDefaultTask */
/**
  * @brief  Function implementing the defaultTask thread.
  * @param  argument: Not used 
  * @retval None
  */
/* USER CODE END Header_StartDefaultTask */
void StartDefaultTask(void *argument)
{
  /* init code for USB_DEVICE */
  MX_USB_DEVICE_Init();
  /* USER CODE BEGIN StartDefaultTask */
	 osVersion_t osVersion;
	 char id_buf[20];
	 unsigned char id_size=20;

	HAL_GPIO_WritePin(USB2_FS_ENUM_CTL_GPIO_Port,USB2_FS_ENUM_CTL_Pin, GPIO_PIN_SET);
	if(isWakeUpReset()){//judge reset source form "wakeup event"

		__HAL_PWR_CLEAR_FLAG(PWR_FLAG_WU);
		__HAL_PWR_CLEAR_FLAG(PWR_FLAG_SB);

		if(HAL_GPIO_ReadPin(SYS_POWER_BTN_GPIO_Port, SYS_POWER_BTN_Pin)==GPIO_PIN_SET){
			if(HAL_GPIO_ReadPin(SYS_CUSTOM_BTN_GPIO_Port, SYS_CUSTOM_BTN_Pin)==GPIO_PIN_RESET)
				NaviKit.sys.next_sta = dfu;
			else{
				NaviKit.sys.power_btn = true;
			}
			Log(info,sys,"EC Reset source :Power Button WakeUP");
		}else{
			NaviKit.sys.next_sta = idle;
			Log(info,sys,"EC Reset source :RTC WakeUP");
			enter_standby_state();
		}
	}else{//judge reset source "power on"
		Log(info,sys,"EC Reset source :PowerON");
		if(HAL_GPIO_ReadPin(SYS_CUSTOM_BTN_GPIO_Port, SYS_CUSTOM_BTN_Pin)==GPIO_PIN_RESET){
			Log(debug,sys,"EC next state isp");
			NaviKit.sys.next_sta = isp;
		}else{
			NaviKit.sys.next_sta = idle;
		}
		TaskBeep(50,1);
	}

	Log(info,sys,"----------------------------------------------");
	Log(info,sys,"Copyright (c) Powered by www.autolabor.com.cn");

	Log(info,sys,"EC Firmware: %s[%s], build: %s, %s, by STD:%u",APP_VERSION,DEPLOY_MODE,__DATE__ ,__TIME__,__STDC_VERSION__  );
	Log(info,sys,"HAL Version: %u ", HAL_GetHalVersion());
	Log(info,sys,"Revision ID: %u ", HAL_GetREVID());
	Log(info,sys,"Device ID: %u ", HAL_GetDEVID());
	Log(info,sys,"Chip UID: %u%u%u ", HAL_GetUIDw0(),HAL_GetUIDw1(),HAL_GetUIDw2());

	if(osOK == osKernelGetInfo(&osVersion,id_buf,id_size)){
		Log(info,sys,"OS Kernel Version: %u ", osVersion.kernel);
		Log(info,sys,"OS Kernel ID: %s ",id_buf);
	}
	Log(info,sys,"Core initial successfully");
	Log(info,sys,"----------------------------------------------");

  /* Infinite loop */
  for(;;)
  {
//	 HAL_IWDG_Refresh(&hiwdg);
	osDelay(20);
    if(NaviKit.sys.sta != NaviKit.sys.next_sta){
    	switch(NaviKit.sys.next_sta){
			case standby:  {
				enter_standby_state();
			}break;
			case idle:  {
				enter_idle_state(100);
		    	NaviKit.sys.sta = NaviKit.sys.next_sta;
			} break;
			case run: {
//				if(NaviKit.pmb.rails.main_pwr>19){
					enter_run_state(100);
					NaviKit.sys.sta = NaviKit.sys.next_sta;
//				}else{
//					NaviKit.sys.next_sta = NaviKit.sys.sta;
//					TaskBeep(500,2);
//					Log(error,pmb,"Main power not exist, retry after plug in it.");
//					 Log(fatal,pmb,"Main power is exception:%dmV",(uint32_t)(NaviKit.pmb.rails.main_pwr*1000));
//				}
			}break;
			case sleep:{
				enter_sleep_state(100);
		    	NaviKit.sys.sta = NaviKit.sys.next_sta;
			}break;
			case dfu:{
//				if(NaviKit.pmb.rails.main_pwr>19){
					enter_dfu_state(100);
					NaviKit.sys.sta = NaviKit.sys.next_sta;
//				}else{
//					NaviKit.sys.next_sta = NaviKit.sys.sta;
//					TaskBeep(500,2);
//					Log(error,pmb,"Main power not exist, retry after plug in it.");
//					 Log(fatal,pmb,"Main power is exception:%dmV",(uint32_t)(NaviKit.pmb.rails.main_pwr*1000));
//				}
			}break;
			case isp:{
				enter_isp_state();
		    	NaviKit.sys.sta = NaviKit.sys.next_sta;
			}break;
    	}
    }

	  if(NaviKit.sys.sta == idle && NaviKit.sys.next_sta == idle){//idle state
//			  if((NaviKit.pmb.sta.chrg_stat1 && NaviKit.pmb.sta.chrg_stat2)
//			  || (NaviKit.pmb.sta.chrg_stat1 && !NaviKit.pmb.sta.chrg_stat2)){//Not Charge or float charge
//				  NaviKit.sys.next_sta = standby;
//			  }

		  if(!osTimerIsRunning(IdleStateHoldTimerHandle)){
		  			osTimerStart(IdleStateHoldTimerHandle,5000);
		  }
	  }

  }
  /* USER CODE END StartDefaultTask */
}

/* USER CODE BEGIN Header_StartLedBlinkTask */
/**
* @brief Function implementing the LedBlinkTask thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_StartLedBlinkTask */
void StartLedBlinkTask(void *argument)
{
  /* USER CODE BEGIN StartLedBlinkTask */
  /* Infinite loop */
//	Log(trace,"Start LED Blink");
	for(;;)
	{

	  osDelay(1000);
		switch(NaviKit.sys.sta){
		case run: {
				PWR_Enable(SYS_PWR_LED,true,0);//turn on power led

				PWR_Enable(SYS_RUN_LED,true,50);//turn on sys run led
				PWR_Enable(SYS_RUN_LED,false,0);//turn off sys run led
			}break;
		case idle:{
			    PWR_Enable(SYS_PWR_LED,false,0);//turn on power led//turn off power led

				PWR_Enable(SYS_RUN_LED,true,20);//turn on sys run led
				PWR_Enable(SYS_RUN_LED,false,3000);//turn off sys run led
			}break;
		case sleep:{//sleep mode
			  for(uint16_t i=0;i<25;i++){//20 light level
				  for(uint16_t j=0;j<3;j++){//the time length of every light level
					  PWR_Enable(SYS_PWR_LED,false,0);
					  PWR_Enable(SYS_RUN_LED,false,0);
					  osDelay(i);
					  PWR_Enable(SYS_PWR_LED,true,0);
					  PWR_Enable(SYS_RUN_LED,true,0);
					  osDelay(25-i);
				  }
			  }
			  for(uint16_t i=0;i<25;i++){
				  for(uint16_t j=0;j<3;j++){
					  PWR_Enable(SYS_PWR_LED,false,0);
					  PWR_Enable(SYS_RUN_LED,false,0);
					  osDelay(25-i);
					  PWR_Enable(SYS_PWR_LED,true,0);
					  PWR_Enable(SYS_RUN_LED,true,0);
					  osDelay(i);
				  }
			  }
		}break;
		case dfu:{
			  PWR_Enable(SYS_PWR_LED,!PWR_Status(SYS_PWR_LED),0);
			  PWR_Enable(SYS_RUN_LED,!PWR_Status(SYS_PWR_LED),0);
		}break;
		default : break;
		}
	}
  /* USER CODE END StartLedBlinkTask */
}

/* USER CODE BEGIN Header_StartCoulombRead */
/**
* @brief Function implementing the CoulombRead thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_StartCoulombRead */
void StartCoulombRead(void *argument)
{
  /* USER CODE BEGIN StartCoulombRead */
//	Log(trace,"Start Coulomb Read Task");
	//写寄存器方法
  coulomb_write_config_load();
  coulomb_write_config_actual_to_raw();
  coulomb_write_config();
  //读寄存器方法
  coulomb_read_status_and_config();
  coulomb_read_status_raw_to_actual();
  coulomb_read_config_raw_to_actual();

  /* Infinite loop */
  for(;;)
  {
    coulomb_read_status_and_config();
    coulomb_read_status_raw_to_actual();
	  if(NaviKit.sys.sta == run)
		  osDelay(500);
	  else
		  osDelay(5000);
  }
  /* USER CODE END StartCoulombRead */
}

/* USER CODE BEGIN Header_StartPowerMonitTask */
/**
* @brief Function: Monit som power status and PMB status
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_StartPowerMonitTask */
void StartPowerMonitTask(void *argument)
{
  /* USER CODE BEGIN StartPowerMonitTask */
//	Log(trace,"Start Power Monitor Task");
	HAL_ADCEx_Calibration_Start(&hadc1);
	HAL_ADC_Start_DMA(&hadc1, (uint32_t*)&(NaviKit.pmb.rails.adc), ADC_CH_COUNT);
	osDelay(100);
  /* Infinite loop */
  for(;;)
  {

		if(NaviKit.pmb.rails.main_pwr > 30){
				TaskBeep(200,1);
			 Log(fatal,pmb,"Main power is exception:%dmV",(uint32_t)(NaviKit.pmb.rails.main_pwr*1000));
		}
		if(NaviKit.pmb.rails.bkp_bat > 15){
			 Log(fatal,pmb,"Backup battery is exception:%dmV",(uint32_t)(NaviKit.pmb.rails.bkp_bat*1000));
				TaskBeep(200,1);
		}
		//stat1 stat2   lead-acid
		//1		1		Not Charging
		//1		0		Float Charge
		//0		1		Absorption Charge
		//0		0		Bulk Charge
		NaviKit.pmb.sta.chrg_stat1 = (bool)HAL_GPIO_ReadPin(PMB_CHRG_STAT1_GPIO_Port, PMB_CHRG_STAT1_Pin);
		NaviKit.pmb.sta.chrg_stat2 = (bool)HAL_GPIO_ReadPin(PMB_CHRG_STAT2_GPIO_Port, PMB_CHRG_STAT2_Pin);

		if(!NaviKit.pmb.sta.chrg_stat1 && !NaviKit.pmb.sta.chrg_stat2)
			Log(trace,pmb,"Backup battery status:%dmV Bulk Charge(Vth=12.6V)",(uint32_t)(NaviKit.pmb.rails.bkp_bat*1000));
		if(!NaviKit.pmb.sta.chrg_stat1 && NaviKit.pmb.sta.chrg_stat2)
			Log(trace,pmb,"Backup battery status:%dmV Absorption Charge(Vth=14.4V)",(uint32_t)(NaviKit.pmb.rails.bkp_bat*1000));
		if(NaviKit.pmb.sta.chrg_stat1 && !NaviKit.pmb.sta.chrg_stat2)
			Log(trace,pmb,"Backup battery status:%dmV Float Charge(Vth=13.3V)",(uint32_t)(NaviKit.pmb.rails.bkp_bat*1000));
		if(NaviKit.pmb.sta.chrg_stat1 && NaviKit.pmb.sta.chrg_stat2)
			Log(trace,pmb,"Backup battery status:%dmV Not Charge",(uint32_t)(NaviKit.pmb.rails.bkp_bat*1000));

		if(NaviKit.sys.sta == run || NaviKit.sys.sta == dfu ){
			if(NaviKit.pmb.rails.main_pwr < 19){
				TaskBeep(200,1);
				 Log(warning,pmb,"Main power has been lost, please shutdown computer as soon as possible:%dmV",(uint32_t)(NaviKit.pmb.rails.main_pwr*1000));
			}else
				Log(trace,pmb,"Main power rail regular:%dmV",(uint32_t)(NaviKit.pmb.rails.main_pwr*1000));

			if(NaviKit.pmb.rails.out_24v > 26.4 || NaviKit.pmb.rails.out_24v < 21.6)
				 Log(fatal,pmb,"24V(±10%%) power rail exception:%dmV",(uint32_t)(NaviKit.pmb.rails.out_24v*1000));
			else
				Log(trace,pmb,"24V(±10%%) power rail regular:%dmV",(uint32_t)(NaviKit.pmb.rails.out_24v*1000));

			if(NaviKit.pmb.rails.out_5v > 5.5 || NaviKit.pmb.rails.out_5v < 4.5)
				 Log(fatal,pmb,"5V(±10%%) power rail exception:%dmV",(uint32_t)(NaviKit.pmb.rails.out_5v*1000));
			else
				Log(trace,pmb,"5V(±10%%) power rail regular:%dmV",(uint32_t)(NaviKit.pmb.rails.out_5v*1000));

			if(NaviKit.pmb.rails.out_12v > 13.2 || NaviKit.pmb.rails.out_12v < 10.8)
				 Log(fatal ,pmb,"12V(±10%%) power rail exception:%dmV",(uint32_t)(NaviKit.pmb.rails.out_12v*1000));
			else
				Log(trace,pmb,"12V(±10%%) power rail regular:%dmV",(uint32_t)(NaviKit.pmb.rails.out_12v*1000));

			if(NaviKit.pmb.rails.bkp_bat < 9.5)
				 Log(warning,pmb,"Backup battery exception:%dmV",(uint32_t)(NaviKit.pmb.rails.bkp_bat*1000));
			else
				Log(trace,pmb,"Backup battery is regular:%dmV",(uint32_t)(NaviKit.pmb.rails.bkp_bat*1000));

		    osDelay(2000);

	  }else {//not run state
		  osDelay(5000);

	  }
//		Log(debug,sys,"state :%d",NaviKit.sys.sta);
//		Log(debug,sys,"next_state :%d",NaviKit.sys.next_sta);

  }
  /* USER CODE END StartPowerMonitTask */
}

/* USER CODE BEGIN Header_StartEventDetect */
/**
* @brief Function implementing the EventDetect thread.
* @param argument: Not used
* @retval None
*/
/* USER CODE END Header_StartEventDetect */
void StartEventDetect(void *argument)
{
  /* USER CODE BEGIN StartEventDetect */
  /* Infinite loop */
//	Log(trace,"Start Event Detect Task.");
  for(;;)
  {
	  	  //power button
		if(NaviKit.sys.power_btn && !osTimerIsRunning(PwrBtnLongPressTimerHandle)){
			osTimerStart(PwrBtnLongPressTimerHandle,1500);
			osTimerStart(PwrBtnShortPressTimerHandle,100);
		}
	    osDelay(2);
		if(!NaviKit.sys.power_btn && osTimerIsRunning(PwrBtnLongPressTimerHandle)){
			osTimerStop(PwrBtnLongPressTimerHandle);
			osTimerStop(PwrBtnShortPressTimerHandle);
		}
	    osDelay(2);
		//custom button
		if(!NaviKit.sys.custom_btn && osTimerIsRunning(CustBtnLongPressTimerHandle)){
			osTimerStop(CustBtnLongPressTimerHandle);
			osTimerStop(CustBtnShortPressTimerHandle);
		}
	    osDelay(2);
		if(NaviKit.sys.custom_btn && !osTimerIsRunning(CustBtnLongPressTimerHandle)){
			osTimerStart(CustBtnLongPressTimerHandle,1500);
			osTimerStart(CustBtnShortPressTimerHandle,100);
		}
	    osDelay(2);
  }
  /* USER CODE END StartEventDetect */
}

/* Private application code --------------------------------------------------*/
/* USER CODE BEGIN Application */

void StartCdcMonitorTask(void *argument){
	for(;;){
		if(flag_restart && port_restart<12){
			flag_restart = false;
			uint8_t port_restart_temp = port_restart;
			Log(info,sys,"Port%d restart",port_restart_temp);
			PWR_Enable(port_restart_temp, false,400);
			TaskBeep(50,1);
			PWR_Enable(port_restart_temp, true,0);
		}
		osDelay(200);
	}
}
void StartLogtoUartTask(void *argument){
	
	// HAL_UART_Transmit(&huart1,(uint8_t *)&ch,1,2);
}

void StartTestTask1(void *argument){
	uint8_t i=0;
	for(;;){
		Log(debug,sys,"test task 1 [%d].",i++);
		osDelay(1000);
	}
}
void StartTestTask2(void *argument){
	uint8_t i=0;
	for(;;){
		Log(debug,sys,"test task 2 [%d].",i++);
		osDelay(1000);
	}
}
void PwrBtnLongPressTimerCallback(void *argument)
{
  Log(trace,sys,"power btn long pressed.");
    switch(NaviKit.sys.sta){
      case run:  {NaviKit.sys.next_sta = idle;Log(trace,sys,"change to idle");      }break;//system is run now, user request to idle
      case idle: {NaviKit.sys.next_sta = run;Log(trace,sys,"change to run");      }break;//system is idle now , user request to power on
      case dfu:  {NaviKit.sys.next_sta = idle;Log(trace,sys,"change to idle");      }break;
      case sleep:{NaviKit.sys.next_sta = run;Log(trace,sys,"change to run");      }break;
      case isp:  {NaviKit.sys.next_sta = idle;Log(trace,sys,"change to idle");      }break;
      default : break;
    }
}
void CustBtnLongPressTimerCallback(void *argument)
{
  Log(trace,sys,"custom btn long pressed.");
    switch(NaviKit.sys.sta){
      case run:{//system is run now, user request to reboot SOM
    	  som_reboot(100);
      }break;
      case idle:{
      }break;
      case dfu:{
    	  som_reboot(100);
      }break;
      case sleep:{
      }break;
      default : break;
    }
}
void PwrBtnShortPressTimerCallback(void *argument)
{
  Log(trace,sys,"power btn short pressed.");
    switch(NaviKit.sys.sta){
      case run:  {//som is running, send sleep requeset to operate system
    	  Log(trace,som,"Request operate system pop up the shutdown dialog.");
    	  PWR_Enable(SOM_SLEEP,true,100);
    	  PWR_Enable(SOM_SLEEP,false,0);
      }break;
      case idle: {     }break;//system is idle now , user request to power on
      case dfu:  {      }break;
      case sleep:{     }break;
      case isp:  {       }break;
      default : break;
    }
}
void CustBtnShortPressTimerCallback(void *argument)
{
  Log(trace,sys,"custom btn short pressed.");
    switch(NaviKit.sys.sta){
      case run:{
      }break;
      case idle:{
      }break;
      case dfu:{
      }break;
      case sleep:{
      }break;
      default : break;
    }
}
void IdleStateHoldTimerCallback(void *argument){
	if(NaviKit.sys.sta == idle && NaviKit.sys.next_sta == idle){
	  Log(trace,sys,"Idle state duration more than 5000ms.");
	  NaviKit.sys.next_sta = standby;
	}
}

/* USER CODE END Application */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
